AC_DEFUN([AX_GSL], 
[
ax_gsl_ok=no

AC_ARG_WITH(gsl,
	[AC_HELP_STRING([--with-gsl=<lib>], [use gsl library <lib>])])

AS_IF([test -z "$with_gsl" && test "${with_gsl+set}" = set],
      [AC_MSG_WARN([--with-gsl=<EMPTY>])],[])

AS_CASE(["$with_gsl"],
        [yes],[ax_gsl_ok=yes],
        [no|""],[ax_gsl_ok=disable],
        [-* | */* | *.a | *.so | *.so.* | *.o],[GSL_LIBS="$with_gsl"; ax_gsl_ok=yes],
        [GSL_LIBS="-l$with_gsl"; ax_gsl_ok=yes])

AS_IF([test "x$ax_gsl_ok" = xyes],
      [LIBS+=" $GSL_LIBS";
       AC_MSG_CHECKING([linking gsl])
       AC_LANG_PUSH([C])
       m4_define([AX_CHECK_GSL_PROGRAM],
                 [AC_LANG_PROGRAM([[
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>]],         
                 [[gsl_rng_env_setup()]])])
       AC_LINK_IFELSE([AX_CHECK_GSL_PROGRAM],
                      [AC_MSG_RESULT([ok])],
                      [AC_MSG_RESULT([failed]);AC_MSG_FAILURE([--with-gsl was given, but linking failed])])
       AC_LANG_POP([C])],[])
]) 
