/**************************************************************************
 *                                                                        *
 *   Copyright (C) 2012: University of Warsaw                             *
 *   Authors:            Pawel Zielinski <pzielins@icm.edu.pl>            *
 *                       Maciej Dlugosz  <mdlugosz@cent.uw.edu.pl>        *
 *                                                                        *
 *   This program is free software; you can redistribute it and/or modify *
 *   it under the terms of the GNU General Public License as published by *
 *   the Free Software Foundation; either version 3 of the License, or    *
 *   (at your option) any later version.                                  *
 *                                                                        *
 *   This program is distributed in the hope that it will be useful,      *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 *   GNU General Public License for more details.                         *
 *                                                                        *
 *   You should have received a copy of the GNU General Public License    *
 *   along with this program; if not, see http://www.gnu.org/licenses     *
 *   or write to the Free Software Foundation,Inc., 51 Franklin Street,   *
 *   Fifth Floor, Boston, MA 02110-1301  USA                              *
 *                                                                        *
 **************************************************************************/

#ifndef VERLET_CUH
#define	VERLET_CUH

#include "../defs.h"

class Verlet_impl;

class Verlet {
public:
    Verlet();
    bool init( bool pbc, DOUBLE* coords, INT UDIM, INT u_size, DOUBLE u_cutoff, bool comp_indxs );
    INT buildlist( DOUBLE* d_out );
    void setLists( INT* kkeys, INT* kvals, INT* indxs );
    void setParams( INT vcount, DOUBLE vroff );
    void resetIter(){ iter_ = 0; }
    void incIter(){ iter_ = (iter_ + 1) % Rcount_; }
    INT getIter() { return iter_; }
    INT* getkkeys();
    INT* getkvals();
    INT* getkindxs();
    bool useBruteForce();
    ~Verlet();
private:
    Verlet_impl* o_;
    Verlet(const Verlet& orig){}
    INT iter_;
    INT Rcount_;
    DOUBLE Roff_;
    INT retsize_;
};

#endif	/* VERLET_CUH */
