/**************************************************************************
 *                                                                        *
 *   Copyright (C) 2011-2012: University of Warsaw                        *
 *   Authors:            Pawel Zielinski <pzielins@icm.edu.pl>            *
 *                       Maciej Dlugosz  <mdlugosz@cent.uw.edu.pl>        *
 *                                                                        *
 *   This program is free software; you can redistribute it and/or modify *
 *   it under the terms of the GNU General Public License as published by *
 *   the Free Software Foundation; either version 3 of the License, or    *
 *   (at your option) any later version.                                  *
 *                                                                        *
 *   This program is distributed in the hope that it will be useful,      *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 *   GNU General Public License for more details.                         *
 *                                                                        *
 *   You should have received a copy of the GNU General Public License    *
 *   along with this program; if not, see http://www.gnu.org/licenses     *
 *   or write to the Free Software Foundation,Inc., 51 Franklin Street,   *
 *   Fifth Floor, Boston, MA 02110-1301  USA                              *
 *                                                                        *
 **************************************************************************/

#ifndef HTABLE_KP_H
#define HTABLE_KP_H

#include "defs.h"

typedef struct
{
    INT cap;
    INT end;
    key_pid* vals;
} hash_entry_kp;

typedef struct 
{
    INT size;
    hash_entry_kp* entrs;
} hash_table_kp;

hash_table_kp* create_hash_table_kp( INT size, INT icap );

void free_hash_table_kp( hash_table_kp* ht );

void add_to_hash_table_kp( hash_table_kp* ht, key_pid kp );

hash_entry_kp* find_elem_ht_kp( hash_table_kp* ht, INT key );

#endif /* HTABLE_KP */

