!include <Win32.Mak>
.SUFFIXES: .exe .obj .c .cpp .cu

cflags = $(cflags) /I "$(CUDA_INC_PATH)"
conlibs = $(conlibs) /LIBPATH:"$(CUDA_LIB_PATH)" /LIBPATH:"$(NVSDKCOMPUTE_ROOT)\C\common\lib"
!IF "$(CPU)" == "i386"
conlibs = $(conlibs) cudart.lib cublas.lib
!ELSE
conlibs = $(conlibs) cudart.lib cublas.lib
!ENDIF
cvars = $(cvars) -DUSE_CUDA -DUSE_FLOAT -DUSE_THRUST -DHAVE_ERFC
#for 64 also WIN32!!
cnvccvars = $(cvars) -DWIN32 -DHAVE_ISINF -DHAVE_ISNAN
cnvccinc = -I"$(NVSDKCOMPUTE_ROOT)\C\common\inc\cudpp"
#change for your architecture
cnvccopt = -O3 -arch=sm_20
nvcc = "$(CUDA_BIN_PATH)\nvcc"
copenmp = 
!IFDEF OPENMP
copenmp=/openmp
!ENDIF

all: $(OUTDIR) $(OUTDIR)\bd_flex.exe

$(OUTDIR) :
    if not exist "$(OUTDIR)/$(NULL)" mkdir $(OUTDIR)
	
.c.obj:
    $(cc) $(cflags) $(cdebug) $(cvars) $(copenmp) /TC /Fo"$(OUTDIR)\\" /Fd"$(OUTDIR)\\" $<
	
.cu.obj:
    $(nvcc) $(cnvccopt) -Xcompiler "$(cdebug) $(cnvccvars) $(copenmp)" -c $< -o $(OUTDIR)\$(*F).obj > nul

CS = diff_alg\cuda
PS = potentials\cuda
	
SS = $(CS)\diff_comp.obj $(CS)\diff_decl.obj $(CS)\diff_equation.obj \
 $(CS)\diff_rand.obj $(CS)\diff_tensor.obj $(CS)\newton.obj diff_alg\cholesky_mpi.obj \
 $(PS)\calc_func.obj ..\common\cuda\sorter.obj

$(OUTDIR)\bd_flex.exe: *.obj ..\common\*.obj potentials\*.obj $(SS) 
    $(link) $(conflags) -out:$(OUTDIR)\bd_flex.exe $(OUTDIR)\*.obj $(conlibs)
	del /Q $(OUTDIR)\*.obj
	
clean:
        $(CLEANUP)
