/**************************************************************************
 *                                                                        *
 *   Copyright (C) 2010 - 2012: University of Warsaw                      *
 *   Authors:            Pawel Zielinski <pzielins@icm.edu.pl>            *
 *                       Maciej Dlugosz  <mdlugosz@cent.uw.edu.pl>        *
 *                                                                        *
 *   This program is free software; you can redistribute it and/or modify *
 *   it under the terms of the GNU General Public License as published by *
 *   the Free Software Foundation; either version 3 of the License, or    *
 *   (at your option) any later version.                                  *
 *                                                                        *
 *   This program is distributed in the hope that it will be useful,      *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 *   GNU General Public License for more details.                         *
 *                                                                        *
 *   You should have received a copy of the GNU General Public License    *
 *   along with this program; if not, see http://www.gnu.org/licenses     *
 *   or write to the Free Software Foundation,Inc., 51 Franklin Street,   *
 *   Fifth Floor, Boston, MA 02110-1301  USA                              *
 *                                                                        *
 **************************************************************************/

#include "math_help.h"

#include "../common/math_common.h"

void get_i2_norms( int p1, int p2, DOUBLE* e1, DOUBLE* r_norm, DOUBLE* r_sq )
{
    DOUBLE* v1 = coord + p1*DIMS1;
    DOUBLE* v2 = coord + p2*DIMS1;
    get_v2_norms( v1, v2, e1, r_norm, r_sq );
}

void get_i2_sq( int p1, int p2, DOUBLE* r_sq )
{
    DOUBLE* v1 = coord + p1*DIMS1;
    DOUBLE* v2 = coord + p2*DIMS1;
    get_v2_sq( v1, v2, r_sq );
}

void get_i2_norms_no( int p1, int p2, DOUBLE* e1, DOUBLE* r_norm, DOUBLE* r_sq )
{
    DOUBLE* v1 = coord + p1*DIMS1;
    DOUBLE* v2 = coord + p2*DIMS1;
    get_v2_norms_no( v1, v2, e1, r_norm, r_sq );
}

void get_i3_norms( int p1, int p2, int p3, DOUBLE* e1, DOUBLE* e2 )
{
    DOUBLE* v1 = coord + p1*DIMS1;
    DOUBLE* v2 = coord + p2*DIMS1;
    DOUBLE* v3 = coord + p3*DIMS1;
    DOUBLE nrm1;
    DOUBLE nrm2;

    trans_dist_vec( v1, v2, e1 );

    trans_dist_vec( v3, v2, e2 );

    nrm1 = 1.0f / norm3v(e1);
    nrm2 = 1.0f / norm3v(e2);
    e1[0] *= nrm1;
    e1[1] *= nrm1;
    e1[2] *= nrm1;

    e2[0] *= nrm2;
    e2[1] *= nrm2;
    e2[2] *= nrm2;
}

